## grass 7.0.1

=== man/Makefile ===
MODULE_TOPDIR = ..

include $(MODULE_TOPDIR)/include/Make/Other.make

MANPAGES := $(patsubst $(HTMLDIR)/%.html,$(MANDIR)/%.$(MANSECT),$(wildcard $(HTMLDIR)/*.html))

DSTFILES := \
	$(HTMLDIR)/grassdocs.css \
	$(HTMLDIR)/grass_logo.png \
	$(HTMLDIR)/grass_icon.png

categories = \
	d:display \
	db:database \
	g:general \
	i:imagery \
	m:misc \
	ps:postscript \
	r:raster \
	r3:raster3d \
	t:temporal \
	v:vector

IDXCATS := $(foreach cat,$(categories),$(lastword $(subst :, ,$(cat))))

IDXSRC = full_index index topics keywords $(IDXCATS)

INDICES := $(patsubst %,$(HTMLDIR)/%.html,$(IDXSRC))

ALL_HTML := $(wildcard $(HTMLDIR)/*.*.html)

ifneq (@(type sphinx-build2 > /dev/null),)
SPHINXBUILD   = sphinx-build2
endif
ifneq (@(type sphinx-build > /dev/null),)
SPHINXBUILD   = sphinx-build
endif

default: $(DSTFILES)
	@echo "Generating HTML manual pages index (help system)..."
	$(MAKE) $(INDICES)
	$(call build,check)
	$(MAKE) manpages

# This must be a separate target so that evaluation of $(MANPAGES)
# is delayed until the indices have been generated
manpages:
	$(MAKE) $(MANPAGES)

.PHONY: manpages

define build
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_$(1).py $(2)
endef

define build_topics
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_topics.py $(HTMLDIR)
endef

define build_keywords
GISBASE="$(RUN_GISBASE)" ARCH="$(ARCH)" ARCH_DISTDIR="$(ARCH_DISTDIR)" \
	VERSION_NUMBER=$(GRASS_VERSION_NUMBER) VERSION_DATE=$(GRASS_VERSION_DATE) \
	$(PYTHON) ./build_keywords.py $(HTMLDIR)
endef

$(HTMLDIR)/topics.html: $(ALL_HTML)
	$(call build_topics)
	touch $@

$(HTMLDIR)/full_index.html: $(ALL_HTML) build_full_index.py build_html.py
	$(call build,full_index)
	touch $@

$(HTMLDIR)/index.html: build_index.py build_html.py
	$(call build,index)
	touch $@

$(HTMLDIR)/keywords.html: $(ALL_HTML)
	$(call build_keywords)
	touch $@

define category_rule
$$(HTMLDIR)/$(2).html: $$(wildcard $$(HTMLDIR)/$(1).*.html) build_class.py build_html.py
	$$(call build,class,$(1) $(2))
	touch $$@
endef

$(foreach cat,$(categories),$(eval $(call category_rule,$(firstword $(subst :, ,$(cat))),$(lastword $(subst :, ,$(cat))))))

$(HTMLDIR)/grassdocs.css: grassdocs.css
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/grass_logo.png: grass_logo.png
	$(INSTALL_DATA) $< $@

$(HTMLDIR)/grass_icon.png: grass_icon.png
	$(INSTALL_DATA) $< $@

=== scripts/Makefile ===
MODULE_TOPDIR = ..

SUBDIRS = \
	d.correlate \
	d.out.file \
	d.to.rast \
	d.polar \
	d.rast.edit \
	d.rast.leg \
	d.redraw \
	d.shade \
	d.what.rast \
	d.what.vect \
	db.dropcolumn \
	db.droptable \
	db.in.ogr \
	db.out.ogr \
	db.test \
	db.univar \
	g.extension \
	g.extension.all \
	g.manual \
	i.colors.enhance \
	i.image.mosaic \
	i.in.spotvgt \
	i.oif \
	i.pansharpen \
	i.spectral \
	i.tasscap \
	m.proj \
	r.blend \
	r.buffer.lowmem \
	r.colors.stddev \
	r.fillnulls \
	r.grow \
	r.in.aster \
	r.in.srtm \
	r.in.wms \
	r.mask \
	r.out.xyz \
	r.pack \
	r.plane \
	r.reclass.area \
	r.rgb \
	r.shade \
	r.tileset \
	r.unpack \
	r3.in.xyz \
	v.build.all \
	v.centroids \
	v.db.addcolumn \
	v.db.addtable \
	v.db.join \
	v.db.dropcolumn \
	v.db.droprow \
	v.db.droptable \
	v.db.renamecolumn \
	v.db.reconnect.all \
	v.db.univar \
	v.db.update \
	v.dissolve \
	v.in.e00 \
	v.in.geonames \
	v.in.lines \
	v.in.mapgen \
	v.in.wfs \
	v.rast.stats \
	v.report \
	v.pack \
	v.to.lines \
	v.unpack \
	v.what.strds \
	v.what.vect \
	wxpyimgview \
	v.krige

include $(MODULE_TOPDIR)/include/Make/Dir.make

default: parsubdirs

=== gui/wxpython/Makefile ===
MODULE_TOPDIR = ../..

SUBDIRS = docs animation mapswipe gmodeler rlisetup psmap dbmgr vdigit iclass gcp timeline
EXTRA_CLEAN_FILES = menustrings.py build_ext.pyc xml/menudata.xml xml/module_tree_menudata.xml */*.pyc

include $(MODULE_TOPDIR)/include/Make/Dir.make
include $(MODULE_TOPDIR)/include/Make/Python.make

DSTDIR = $(GUIDIR)/wxpython

SRCFILES := $(wildcard icons/*.py scripts/*.py xml/*) \
	$(wildcard animation/* core/*.py dbmgr/* gcp/*.py gmodeler/* \
	gui_core/*.py iclass/* lmgr/*.py location_wizard/*.py mapwin/*.py mapdisp/*.py \
	mapswipe/* modules/*.py nviz/*.py psmap/* rlisetup/* timeline/* vdigit/* \
	vnet/*.py web_services/*.py wxplot/*.py iscatt/*.py) \
	gis_set.py gis_set_error.py wxgui.py README

DSTFILES := $(patsubst %,$(DSTDIR)/%,$(SRCFILES)) \
	$(patsubst %.py,$(DSTDIR)/%.pyc,$(filter %.py,$(SRCFILES)))

PYDSTDIRS := $(patsubst %,$(DSTDIR)/%,animation core dbmgr gcp gmodeler \
	gui_core iclass lmgr location_wizard mapwin mapdisp modules nviz psmap \
	mapswipe vdigit wxplot web_services rlisetup vnet timeline iscatt)


DSTDIRS := $(patsubst %,$(DSTDIR)/%,icons scripts xml)

default: $(DSTFILES)
	-$(MAKE) $(DSTDIR)/xml/module_items.xml
	-$(MAKE) xml/menudata.xml
	-$(MAKE) xml/module_tree_menudata.xml
	-$(MAKE) menustrings.py
	$(MAKE) parsubdirs


$(DSTDIR)/%: % | $(PYDSTDIRS) $(DSTDIRS)
	$(INSTALL_DATA) $< $@

xml/menudata.xml: core/toolboxes.py
	$(call run_grass,$(PYTHON) $< > $@)

xml/module_tree_menudata.xml: core/toolboxes.py
	$(call run_grass,$(PYTHON) $< "module_tree" > $@)

menustrings.py: core/menutree.py $(DSTDIR)/xml/menudata.xml $(DSTDIR)/xml/module_tree_menudata.xml $(DSTDIR)/xml/menudata_modeler.xml $(DSTDIR)/xml/menudata_psmap.xml
	@echo "# This is a generated file.\n" > $@
	$(call run_grass,$(PYTHON) $< "manager" >> $@)
	$(call run_grass,$(PYTHON) $< "module_tree" >> $@)
	$(call run_grass,$(PYTHON) $< "modeler" >> $@)
	$(call run_grass,$(PYTHON) $< "psmap" >> $@)

$(DSTDIR)/xml/module_items.xml: tools/build_modules_xml.py
	@echo "Generating interface description for all modules..."
	$(call run_grass,$(PYTHON) $< > $@)

$(PYDSTDIRS): %: | $(DSTDIR)
	$(MKDIR) $@

$(DSTDIRS): %: | $(DSTDIR)
	$(MKDIR) $@

$(DSTDIR):
	$(MKDIR) $@

=== lib/proj/Makefile ===
MODULE_TOPDIR = ../..

LIB = GPROJ

include $(MODULE_TOPDIR)/include/Make/Vars.make

MOD_OBJS := $(filter-out ftol.o,$(AUTO_OBJS))

include $(MODULE_TOPDIR)/include/Make/Lib.make 
include $(MODULE_TOPDIR)/include/Make/Doxygen.make

EXTRA_CFLAGS = $(ZLIBINCPATH) $(GDALCFLAGS)
EXTRA_INC = $(PROJINC)

NAD_TABLES := $(wildcard *.lla)

NT_TABLES = ntv1_can.dat nzgd2kgrid0005.gsb

CSV_FILES := $(wildcard *.csv)

PROJ_DIR = $(ETC)/proj
NAD_DIR  = $(ETC)/proj/nad
CSV_DIR  = $(ETC)/proj/ogr_csv

NAD_DSTFILES := $(patsubst %.lla,$(NAD_DIR)/%,$(NAD_TABLES))
NT_DSTFILES  := $(patsubst %,$(NAD_DIR)/%,$(NT_TABLES))
CSV_DSTFILES := $(patsubst %,$(CSV_DIR)/%,$(CSV_FILES))

NAD_SRCDIR = $(ETC)/proj/nad/src
NAD_SRCFILES := $(patsubst %.lla,$(NAD_SRCDIR)/%.lla,$(NAD_TABLES))

PROJ_TABLES := desc.table parms.table units.table
PROJ_DSTFILES := $(patsubst %,$(PROJ_DIR)/%,$(PROJ_TABLES))

default: lib $(FTOL_OBJ)
	$(MAKE) $(NAD_DSTFILES) $(CSV_DSTFILES) $(PROJ_DSTFILES) $(NAD_SRCFILES)

ifdef MINGW
$(FTOL_OBJ): $(OBJDIR)/ftol.o
	$(INSTALL) $< $@
endif

$(NAD_DSTFILES): $(NAD_DIR)/%: %.lla | $(NAD_DIR)
	$(NAD2BIN) < $< $@

$(NT_DSTFILES): $(NAD_DIR)/%: % | $(NAD_DIR)
	$(INSTALL_DATA) $< $@

$(CSV_DSTFILES): $(CSV_DIR)/%.csv: %.csv | $(CSV_DIR)
	$(INSTALL_DATA) $< $@

$(NAD_SRCFILES): $(NAD_SRCDIR)/%.lla: %.lla | $(NAD_SRCDIR)
	$(INSTALL_DATA) $< $@

$(PROJ_DSTFILES): $(PROJ_DIR)/%: % | $(PROJ_DIR)
	$(INSTALL_DATA) $< $@

$(PROJ_DIR):
	$(MKDIR) $@

$(NAD_DIR): | $(PROJ_DIR)
	$(MKDIR) $@

$(CSV_DIR): | $(PROJ_DIR)
	$(MKDIR) $@

$(NAD_SRCDIR): | $(PROJ_DIR)
	$(MKDIR) $@

# Note for future improvement:
# To allow for cross-compilation, the above NAD_TABLES files should be
# created during installation rather than compilation

#doxygen:
DOXNAME=proj

=== lib/db/dbmi_base/Makefile ===
MODULE_TOPDIR = ../../..

EXTRA_CFLAGS = $(USE_DIRECT) $(USE_BUFFERED_IO)

LIB = DBMIBASE

include $(MODULE_TOPDIR)/include/Make/Lib.make

default: lib

=== lib/db/dbmi_driver/Makefile ===
MODULE_TOPDIR = ../../..

EXTRA_CFLAGS = $(USE_DIRECT) $(USE_BUFFERED_IO) -I../dbmi_base

LIB = DBMIDRIVER

include $(MODULE_TOPDIR)/include/Make/Lib.make

default: lib $(ARCH_INCDIR)/dbstubs.h

=== lib/python/docs/Makefile ===
# Makefile for Sphinx documentation
#
MODULE_TOPDIR=../../..
include $(MODULE_TOPDIR)/include/Make/Vars.make
include $(MODULE_TOPDIR)/include/Make/Rules.make


PAPER         =
BUILDDIR      = _build
BUILDDIR_HTML = $(HTMLDIR)/libpython

MYGISBASE = $(GISBASE)

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) -c . src/
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
SPHINXBUILD     = sphinx-build
SPHINXAPIDOC    = sphinx-apidoc

# some distros come with a different name
BUILD  := $(type $(SPHINXBUILD) >/dev/null)  || (SPHINXBUILD  = sphinx-build2)
APIDOC := $(type $(SPHINXAPIDOC) >/dev/null) || (SPHINXAPIDOC = sphinx-apidoc2)

checksphinx:
	@echo "SPHINXBUILD: Found <$(SPHINXBUILD)>"
	@echo "SPHINXAPIDOC: Found <$(SPHINXAPIDOC)>"
	@(type $(SPHINXBUILD) > /dev/null || (echo "ERROR: Install 'sphinx-build' software first (get from http://sphinx-doc.org)" && exit 1))
	@(type $(SPHINXAPIDOC) > /dev/null || (echo "ERROR: Install 'sphinx-apidoc' software first (get from http://sphinx-doc.org)" && exit 1))

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp checksphinx libpythonapidoc libpythonclean libpythondirhtml libpythondoctest libpythonepub libpythonhelp libpythonhtml libpythonlatex libpythonlatexpdf libpythonman libpythonsinglehtml

.DEFAULT_GOAL := libpythonhelp

libpythonhelp:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  libpythonhtml       to make standalone HTML files"
	@echo "  libpythondirhtml    to make HTML files named index.html in directories"
	@echo "  libpythonsinglehtml to make a single large HTML file"
	@echo "  libpythonepub       to make an epub"
	@echo "  libpythonlatex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  libpythonlatexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  libpythonman        to make manual pages"
	@echo "  libpythondoctest    to run all doctests embedded in the documentation (if enabled)"

libpythonclean:
	-rm -rf $(BUILDDIR)/*
	-rm -f _templates/layout.html
	-rm -f src/ctypes*.rst
	-rm -f src/exceptions.rst
	-rm -f src/imaging.rst
	-rm -f src/pydispatch.rst
	-rm -f src/pygrass.*rst
	-rm -f src/script.rst
	-rm -f src/temporal.rst

libpythonapidoc:
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXAPIDOC) -T -f -o src/ ../imaging/)
	$(call run_grass,$(SPHINXAPIDOC) -T -f -o src/ ../exceptions/)
	$(call run_grass,$(SPHINXAPIDOC) -T -f -o src/ ../pydispatch/)
	$(call run_grass,$(SPHINXAPIDOC) -T -f -o src/ ../pygrass/)
	$(call run_grass,$(SPHINXAPIDOC) -T -f -o src/ ../script/)
	$(call run_grass,$(SPHINXAPIDOC) -T -f -o src/ ../temporal/)

libpythonhtml: checksphinx
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR_HTML))
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR_HTML)"

libpythondirhtml:
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR_HTML))
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR_HTML)"

libpythonsinglehtml:
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR_HTML))
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR_HTML)"

libpythonepub:
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub)
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub/"

libpythonlatex:
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex)
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

libpythonlatexpdf:
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex)
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex/"

libpythonman:
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(MANDIR))
	@echo
	@echo "Build finished. The manual pages are in $(MANDIR)/"

libpythondoctest:
	@echo "SPHINXBUILD: Using <$(SPHINXBUILD)>"
	$(call run_grass,$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest)
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
grass (7.0.1-2build1) wily; urgency=medium

  * No-change rebuild for libnetcdf.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 27 Sep 2015 17:36:04 +0200

grass (7.0.1-2) unstable; urgency=medium

  * Update Vcs-Browser URL to use HTTPS.
  * Drop .0 from LGPL licese shortname in copyright file.
  * Drop obsolete TODO file.
  * Enable parallel builds.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 29 Aug 2015 13:28:25 +0200

grass (7.0.1-1) unstable; urgency=medium

  * Move from experimental to unstable.
  * Add patches for various typos.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 24 Aug 2015 00:50:05 +0200

grass (7.0.1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 30 Jul 2015 23:45:54 +0200

grass (7.0.1~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop typo patches, applied upstream.
  * Support alternative tarball extensions in watch file.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 23 Jul 2015 00:06:10 +0200

grass (7.0.1~rc1-1~exp2) experimental; urgency=medium

  * Enable liblas support.
    (closes: #781227)
  * Require at least liblas 1.8.0-3 for boost dependencies.
  * Change build dependency to liblas-c-dev for capi.
  * Drop unused lintian overrides.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 05 Jul 2015 01:39:05 +0200

grass (7.0.1~rc1-1~exp1) experimental; urgency=medium

  [ Bas Couwenberg ]
  * Use upstream grass startup script, and install custom x-grass7 as x-grass70.
  * Add Conflicts/Provides/Replaces on the grass7* packages by upstream.
  * New upstream release candidate.
  * Refresh patches and mark as Forwarded.
  * Add patches for various typos.

  [ Francesco Paolo Lovergine ]
  * Added liblas-dev b-d to support new Lidar modules.
  * Introduced a separate tag in debian/rules to regenerate debian stuff from 
    templates.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 04 Jul 2015 21:23:04 +0200

grass (7.0.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update python-ctypes-ternary.patch to use if/else instead of and/or.
  * Drop check4dev patch, rely on upstream check.
  * Add build dependency on libpq-dev to grass-dev for libpq-fe.h.
  * Drop patches applied upstream, refresh remaining patches.
  * Update symlinks for images switched from jpg to png.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Feb 2015 23:12:08 +0100

grass (7.0.0~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Remove additional Doxygen files on clean.
  * Drop upstream tarball repacking, fixed upstream.
  * Drop patches applied upstream, refresh remaining patches.
  * Add build dependencies on: zlib1g-dev, python-ply, python-pil.
  * Update copyright file, update copyright years.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 09 Feb 2015 08:53:56 +0100

grass (7.0.0~rc1+ds1-1~exp2) experimental; urgency=medium

  * Add patch to treat GNU/{Hurd,kFreeBSD} like Linux in SC_CONFIG_CFLAGS.
  * Add patch to fix Python ctypes conversion for stat64 struct on Hurd.
  * Add patch to prevent build failures by ignoring HTML description
    errors.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 08 Feb 2015 18:23:42 +0100

grass (7.0.0~rc1+ds1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Repack upstream tarball, remove precompiled Python objects.
  * Add upstream metadata.
  * Update gbp.conf and Vcs-Git URL to use the experimental branch.
  * Update watch file for GRASS 7.0.
  * Drop build dependencies for Tcl/Tk, add build dependencies:
    python-numpy, libnetcdf-dev, netcdf-bin, libblas-dev, liblapack-dev
  * Update Vcs-Browser URL to use cgit instead of gitweb.
  * Update paths to use grass70.
  * Add configure options: --with-netcdf, --with-blas, --with-lapack,
    remove --with-tcltk-includes.
  * Update patches for GRASS 7.
  * Update copyright file, changes:
    - Update copyright years
    - Group files by license
    - Remove unused license sections
  * Add patches for various typos.
  * Fix desktop file with patch instead of d/rules.
  * Use minimal dh rules.
  * Bump Standards-Version to 3.9.6, no changes.
  * Use dpkg-maintscript-helper to replace directories with symlinks.
    (closes: #776349)
  * Update my email to use @debian.org address.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 06 Feb 2015 18:51:17 +0100

=== debian/control ===
Source: grass
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
           Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: autoconf2.13,
               autotools-dev,
               debhelper (>= 9),
               dh-python,
               doxygen,
               fakeroot,
               flex,
               bison,
               graphviz,
               libmotif-dev | lesstif2-dev,
               libcairo2-dev,
               libfftw3-dev,
               libfreetype6-dev,
               libgdal-dev,
               libgeos-dev,
               libglu1-mesa-dev,
               libjpeg-dev,
               libpng-dev,
               libtiff-dev,
               libmysqlclient-dev,
               libncurses5-dev,
               libpq-dev,
               libproj-dev,
# proj-bin needed for nad2bin during config
               proj-bin,
               libreadline-dev,
               libsqlite3-dev,
               libwxgtk3.0-dev,
               libxmu-dev,
# install optipng if compressing the PNG images in the programmers' manual
#              optipng,
               python,
               python-wxgtk3.0,
               python-dev,
               python-numpy,
               python-ply,
               python-pil,
               libnetcdf-dev,
               netcdf-bin,
               libblas-dev,
               liblapack-dev,
               unixodbc-dev,
               zlib1g-dev,
               liblas-c-dev (>= 1.8.0-3~)
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/grass.git
Vcs-Git: git://anonscm.debian.org/pkg-grass/grass.git
Homepage: http://grass.osgeo.org/

Package: grass
Architecture: all
Section: metapackages
Depends: grass-core,
         grass-gui,
         ${misc:Depends}
Recommends: grass-doc
Suggests: grass-dev
Conflicts: grass70,
           grass7
Provides: grass70,
          grass7
Replaces: grass70,
          grass7
Description: Geographic Resources Analysis Support System (GRASS GIS)
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 Install this virtual package to get a full GRASS system.

Package: grass-core
Architecture: any
Depends: ${shlibs:Depends},
         ${python:Depends},
# numpy used by the GRASS Python Library
         python-numpy,
         ${misc:Depends}
Recommends: gdal-bin,
# cs2cs used by m.proj, gdalinfo+gdal_translate used by a number of scripts
            proj-bin
Suggests: grass-doc,
          grass-gui,
          grass-dev,
# used by v.in.e00
          e00compr,
          avce00,
# used by i.spectral
          gnuplot,
# used by v.in.gpsbabel
          gpsbabel,
# used by v.in.garmin
          gpstrans,
# used by NVIZ, d.out.gpsdrive, r.out.mpeg
          netpbm,
# used by v.kridge
          python-rpy2
Breaks: grass (<< 6.4.2-1~)
Conflicts: grass70-core,
           grass7-core
Provides: grass701,
          grass70-core,
          grass7-core
Replaces: grass70-core,
          grass7-core,
          grass (<< 6.4.2-1~)
Description: GRASS GIS core components
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the core processing components, but not the GUI.

Package: grass-gui
Architecture: any
Depends: grass-core,
         ${python:Depends},
         python-wxgtk3.0,
# pyGL needed for wxNviz
         python-opengl,
         xterm | x-terminal-emulator,
         ${misc:Depends}
Recommends:
# gs needed for wxPsmap PDF export
            ghostscript,
# PIL needed for wxPsmap preview
            python-imaging
Breaks: grass (<< 6.4.2-1~)
Conflicts: grass70-gui,
           grass7-gui
Provides: grass70-gui,
          grass7-gui
Replaces: grass (<< 6.4.2-1~),
          grass70-gui,
          grass7-gui
Description: GRASS GIS graphical user interfaces
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the GRASS GUIs.

Package: grass-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: grass,
          grass-dev-doc
Conflicts: grass70-doc,
           grass7-doc
Provides: grass70-doc,
          grass7-doc
Replaces: grass70-doc,
          grass7-doc
Description: GRASS GIS user documentation
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains HTML documentation for the GRASS system.

Package: grass-dev-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         libjs-jquery
Suggests: grass
Conflicts: grass70-dev-doc,
           grass7-dev-doc
Provides: grass70-dev-doc,
          grass7-dev-doc
Replaces: grass70-dev-doc,
          grass7-dev-doc
Description: GRASS GIS Programmers' Manual
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the HTML version of the GRASS Programmers' Manual.

Package: grass-dev
Section: devel
Architecture: any
Depends: grass-core (= ${binary:Version}),
# fakeroot used by patches/htmlgen-fakeroot; see changelog entry for 5.7.0+6.0.0beta2-2
         fakeroot,
         libproj-dev,
         libgdal-dev,
         libfreetype6-dev,
         libpq-dev,
         python,
         ${shlibs:Depends},
         ${misc:Depends}
# Subversion is needed by g.extension, a primary motivator for installing the grass-dev pkg
Recommends: subversion
Suggests: grass-dev-doc,
          pkg-config
Conflicts: grass70-dev,
           grass7-dev
Provides: grass70-dev,
          grass7-dev
Replaces: grass70-dev,
          grass7-dev
Description: GRASS GIS development files
 Commonly referred to as GRASS, this is a Geographic Information
 System (GIS) used for geospatial data management and analysis,
 image processing, graphics/map production, spatial modeling, and
 visualization. GRASS is currently used in academic and commercial
 settings around the world, as well as by many government agencies
 and environmental consulting companies.
 .
 This package contains the header files for developing with GRASS.
 Install this package if you wish to develop software that manipulates
 GRASS data sets or install addons using the g.extension module.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

VERSION=$(shell echo `head -2 $(CURDIR)/include/VERSION` | sed -e 's/ //')
ABI=$(shell echo `head -3 $(CURDIR)/include/VERSION` | sed -e 's/ //g' -e 's/RC/-/')
BASE_NAME=grass$(VERSION)
PKG_NAME=grass

# TODO: fix these
CFLAGS+=-Wno-error=format-security

CFLAGS+=-Wall

TEMPLATES=$(wildcard debian/*.in)

versions: 
	@echo "Version: $(VERSION)"
	@echo "ABI: $(ABI)"

%:
	dh $@ --with autotools_dev,python2 --parallel

override_dh_clean:
	dh_clean

	$(RM) lib/proj/nad2bin
	$(RM) tools/timer/main.o
	$(RM) raster/r.terraflow/IOStream/lib/src/libiostream.a
	$(RM) debian/$(BASE_NAME).1
	$(RM) error.log

	# clean doxygen documentation (programming man)
	$(RM) doxygen_sqlite3.db lib/doxygen_sqlite3.db
	$(RM) -r \
		doxygenhtml \
		html latex \
		rfc/html rfc/latex \
		lib/html lib/latex \
		gui/wxpython/html gui/wxpython/latex
	for LIBRARY in \
		db \
		g3d \
		gis \
		gmath \
		gpde \
		ogsf \
		proj \
		python \
		segment \
		vector \
		vector/dglib ; \
	do \
		$(RM) -r lib/$$LIBRARY/html lib/$$LIBRARY/latex ; \
	done

templates:
	for TEMPLATE in $(TEMPLATES) ; do \
	    sed -e 's/@VERSION@/$(VERSION)/g' -e 's/@ABI@/$(ABI)/g' $$TEMPLATE > `echo $$TEMPLATE | sed 's/.in$$//'` ; \
	done

override_dh_auto_clean:
	[ ! -f $(CURDIR)/include/Make/Platform.make ] || $(MAKE) distclean

override_dh_auto_configure: templates
	dh_auto_configure -- \
                    --prefix=/usr/lib \
                    --enable-socket \
                    --enable-shared \
                    --with-postgres \
                    --with-mysql \
                    --with-cxx \
                    --with-x \
                    --with-gdal \
                    --with-geos \
                    --with-freetype \
                    --with-motif \
                    --with-readline \
                    --with-nls \
                    --with-odbc \
                    --with-netcdf \
                    --with-blas \
                    --with-lapack \
                    --with-sqlite \
                    --enable-largefile \
                    --with-freetype-includes=/usr/include/freetype2 \
                    --with-postgres-includes=$(shell pg_config --includedir) \
                    --with-mysql-includes=$(shell mysql_config --include | sed -e 's/-I//') \
                    --with-proj-share=/usr/share/proj \
                    --with-liblas=/usr/bin/liblas-config \
                    --with-wxwidgets=/usr/bin/wx-config \
                    --with-python \
                    --with-cairo


# This target generates arch-dep stuff, unfortunately most doc requires working bins to 
# be properly generated...
override_dh_auto_build-arch:
	dh_auto_build
	chmod 755 debian/fixpaths.sh

override_dh_auto_build-indep:
	# generate the Programmers' manual (in HTML)
	$(MAKE) htmldocs-single

	# save ~7mb of disk space by compressing PNG images (but takes a long time)
	##for file in `find debian/tmp/programming-manual/ -iname \*.png` ; do \
	##	optipng -o5 $$file ; \
	##done

override_dh_auto_install-arch:
	# install grass core into debian/tmp
	dh_auto_install -- \
		INST_DIR=$(CURDIR)/debian/tmp/usr/lib/$(BASE_NAME) \
		UNIX_BIN=$(CURDIR)/debian/tmp/usr/bin

	# fix links
	debian/fixpaths.sh $(CURDIR)/debian/tmp debian/tmp

	# delete extra license files
	$(RM) debian/tmp/usr/lib/$(BASE_NAME)/etc/license
	
	# delete python compiled bytecode files (maybe dh_python2 takes care of this for us?)
	find debian/tmp/ -type f -name "*.pyc" -delete

	# change section from 1 to .1grass 
	mv debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/grass7.1 debian/$(BASE_NAME).1
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1; do \
		n=`basename $$m .1`; mv $$m debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/$$n.1grass; done
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
		sed -i -e 's/^.TH \(.*\) 1/.TH \1 1grass/' "$$m"; done

	# escape minus signs which are command line options not hyphens
	for m in debian/tmp/usr/lib/$(BASE_NAME)/docs/man/man1/*.1grass; do \
		sed -i -e 's/\([ ([]\)-\([a-z]\)/\1\\-\2/g' \
			-e 's/\([ []\)--\([a-z]\)/\1\\-\\-\2/g' \
			-e 's/\[-\\fB/[\\-\\fB/' \
			-e 's/\[--\\fB/[\\-\\-\\fB/g' \
			-e 's/"\\fB-\([a-zA-Z0-9]\)/"\\fB\\-\1/' \
			-e 's/"\\fB--\([a-zA-Z0-9]\)/"\\fB\\-\\-\1/' \
			-e 's/\\fI-\([a-zA-Z0-9]\)/\\fI\-\1/g' \
			"$$m"; done

	# adjust from build-server build dir to end-user's install dir
	sed -i -e "s+^\(GRASS_HOME[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		-e "s+^\(RUN_GISBASE[ ]*=\) .*+\1 /usr/lib/$(BASE_NAME)+" \
		debian/tmp/usr/lib/$(BASE_NAME)/include/Make/Platform.make

	# install pkg-config file
	install -m 644 grass.pc debian/$(PKG_NAME)-dev/usr/share/pkgconfig/$(BASE_NAME).pc

	# install icon file for debian menu system
	install -d debian/tmp/usr/share/icons \
		debian/tmp/usr/share/applications \
		debian/tmp/usr/bin
	# is there a better way to make these exist?
	mkdir -p debian/tmp/usr/share/icons/hicolor/32x32/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/48x48/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/64x64/apps
	mkdir -p debian/tmp/usr/share/applications
	install -m 644 debian/grass.xpm \
		debian/tmp/usr/share/icons/hicolor/32x32/apps/$(BASE_NAME).xpm
	install -m 644 gui/icons/grass-48x48.png \
		debian/tmp/usr/share/icons/hicolor/48x48/apps/$(BASE_NAME).png
	install -m 644 gui/icons/grass-64x64.png \
		debian/tmp/usr/share/icons/hicolor/64x64/apps/$(BASE_NAME).png
	install -m 644 gui/icons/grass.desktop \
		debian/tmp/usr/share/applications/$(BASE_NAME).desktop

	# install AppStream metadata
	mkdir -p debian/tmp/usr/share/appdata/
	install -m 644 gui/icons/grass.appdata.xml \
		debian/tmp/usr/share/appdata/$(BASE_NAME).appdata.xml

	# install grass wrapper scripts
	install -m 755 debian/x-grass7 debian/tmp/usr/bin/x-$(BASE_NAME)

	ln -fs /usr/lib/$(shell objdump -p /usr/lib/`gdal-config --libs | cut -d' ' -f2 | sed -e 's/-l/lib/'`.so | grep SONAME | cut -d' ' -f18) \
		debian/tmp/usr/lib/$(BASE_NAME)/lib/libgdal.so

	# Remove empty directory
	rmdir debian/tmp/usr/lib/$(BASE_NAME)/gui/wxpython/scripts/

	# Remove files not installed or installed by debhelper
	$(RM) -r debian/tmp/usr/lib/$(BASE_NAME)/AUTHORS \
	         debian/tmp/usr/lib/$(BASE_NAME)/CHANGES \
	         debian/tmp/usr/lib/$(BASE_NAME)/COPYING \
	         debian/tmp/usr/lib/$(BASE_NAME)/GPL.TXT \
	         debian/tmp/usr/lib/$(BASE_NAME)/REQUIREMENTS.html \
	         debian/tmp/usr/lib/$(BASE_NAME)/config.status \
	         debian/tmp/usr/lib/$(BASE_NAME)/contributors.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/contributors_extra.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/translation_status.json \
	         debian/tmp/usr/lib/$(BASE_NAME)/translators.csv \
	         debian/tmp/usr/lib/$(BASE_NAME)/share/appdata/grass.appdata.xml \
	         debian/tmp/usr/lib/$(BASE_NAME)/share/applications/grass.desktop \
	         debian/tmp/usr/lib/$(BASE_NAME)/demolocation/

	# Move image files from /usr/lib/$(BASE_NAME) to /usr/share/$(BASE_NAME)
	mkdir -p debian/tmp/usr/share/$(BASE_NAME)/gui
	mv debian/tmp/usr/lib/$(BASE_NAME)/gui/icons/ debian/tmp/usr/share/$(BASE_NAME)/gui/
	mv debian/tmp/usr/lib/$(BASE_NAME)/gui/images/ debian/tmp/usr/share/$(BASE_NAME)/gui/

	mkdir -p debian/tmp/usr/share/$(BASE_NAME)/gui/wxpython/animation
	mv debian/tmp/usr/lib/grass70/gui/wxpython/animation/wxGUI_animation_tool.jpg debian/tmp/usr/share/$(BASE_NAME)/gui/wxpython/animation/
	
	mkdir -p debian/tmp/usr/share/$(BASE_NAME)/gui/wxpython/dbmgr
	mv debian/tmp/usr/lib/grass70/gui/wxpython/dbmgr/dbmgr_frame.jpg  debian/tmp/usr/share/$(BASE_NAME)/gui/wxpython/dbmgr/

	mkdir -p debian/tmp/usr/share/$(BASE_NAME)/gui/wxpython/gmodeler
	mv debian/tmp/usr/lib/grass70/gui/wxpython/gmodeler/gmodeler_frame.png debian/tmp/usr/share/$(BASE_NAME)/gui/wxpython/gmodeler/

	mkdir -p debian/tmp/usr/share/$(BASE_NAME)/gui/wxpython/iclass
